/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept 'may_open' function
 *
 * Notes:
 *  - Enforce Exploit Detection validation
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 04.X.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_MAY_OPEN_H
#define P_LKRG_EXPLOIT_DETECTION_MAY_OPEN_H

/* per-instance private data */
struct p_may_open_data {
    ktime_t entry_stamp;
};


int p_may_open_ret(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_may_open_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_may_open_hook(void);
void p_uninstall_may_open_hook(void);

#endif
