/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept setgroups syscall
 *
 * Notes:
 *  - Exploit Detection features needs to whitelist process which
 *    legitimately increases their privileges (e.g. 'su', 'sudo', etc.)
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 09.IX.2017
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_SYS_SETGROUPS_H
#define P_LKRG_EXPLOIT_DETECTION_SYS_SETGROUPS_H

/* per-instance private data */
struct p_sys_setgroups_data {
    ktime_t entry_stamp;
};


int p_sys_setgroups_ret(struct kretprobe_instance *ri, struct pt_regs *p_regs);
int p_sys_setgroups_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_sys_setgroups_hook(void);
void p_uninstall_sys_setgroups_hook(void);

#endif
